package com.muyu.system.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.muyu.system.domain.Product;
import com.muyu.system.domain.req.ProductEditReq;
import com.muyu.system.domain.req.ProductQueryReq;
import com.muyu.system.domain.req.ProductSaveReq;
import com.muyu.system.service.ProductService;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.common.security.annotation.RequiresPermissions;

import com.muyu.common.core.web.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 *
 * @author DongZeLiang
 * @date 2024-11-14
 */
@Api(tags = "【请填写功能名称】")
@RestController
@RequestMapping("/product")
public class ProductController extends BaseController {
    @Autowired
    private ProductService productService;

    /**
     * 查询【请填写功能名称】列表
     */
    @ApiOperation("获取【请填写功能名称】列表")
    @RequiresPermissions("product:product:list")
    @GetMapping("/list")
    public Result<TableDataInfo<Product>> list(ProductQueryReq productQueryReq) {
        startPage();
        List<Product> list = productService.list(Product.queryBuild(productQueryReq));
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @ApiOperation("导出【请填写功能名称】列表")
    @RequiresPermissions("product:product:export")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, Product product) {
        List<Product> list = productService.list(product);
        ExcelUtil<Product> util = new ExcelUtil<Product>(Product.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @ApiOperation("获取【请填写功能名称】详细信息")
    @RequiresPermissions("product:product:query")
    @GetMapping(value = "/{id}")
    @ApiImplicitParam(name = "id", value = "id", required = true, dataType = "Long", paramType = "path", dataTypeClass = Long.class)
    public Result<Product> getInfo(@PathVariable("id") Long id) {
        return Result.success(productService.getById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @RequiresPermissions("product:product:add")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    @ApiOperation("新增【请填写功能名称】")
    public Result<String> add(@RequestBody ProductSaveReq productSaveReq) {
        return toAjax(productService.save(Product.saveBuild(productSaveReq)));
    }

    /**
     * 修改【请填写功能名称】
     */
    @RequiresPermissions("product:product:edit")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping("/{id}")
    @ApiOperation("修改【请填写功能名称】")
    public Result<String> edit(@PathVariable Long id, @RequestBody ProductEditReq productEditReq) {
        return toAjax(productService.updateById(Product.editBuild(id,productEditReq)));
    }

    /**
     * 删除【请填写功能名称】
     */
    @RequiresPermissions("product:product:remove")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    @ApiOperation("删除【请填写功能名称】")
    @ApiImplicitParam(name = "id", value = "id", required = true, dataType = "Long", paramType = "path", dataTypeClass = String.class, example = "1,2,3,4")
    public Result<String> remove(@PathVariable List<Long> ids) {
        return toAjax(productService.removeBatchByIds(ids));
    }
}
