package com.muyu.system.domain;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.system.domain.req.ProductEditReq;
import com.muyu.system.domain.req.ProductQueryReq;
import com.muyu.system.domain.req.ProductSaveReq;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.AllArgsConstructor;
import lombok.experimental.SuperBuilder;
import io.swagger.annotations.*;
import com.muyu.common.core.annotation.Excel;

import com.muyu.common.core.web.domain.BaseEntity;

/**
 * 【请填写功能名称】对象 product
 *
 * @author DongZeLiang
 * @date 2024-11-14
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("product")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "Product", description = "【请填写功能名称】")
public class Product extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /** 主键 */
    @TableId(value = "id",type = IdType.AUTO)
    @ApiModelProperty(name = "主键", value = "主键")
    private Long id;

    /** 商品名称 */
    @Excel(name = "商品名称")
    @ApiModelProperty(name = "商品名称", value = "商品名称")
    private String name;

    /** 原价 */
    @Excel(name = "原价")
    @ApiModelProperty(name = "原价", value = "原价")
    private BigDecimal price;

    /** 拼团价格 */
    @Excel(name = "拼团价格")
    @ApiModelProperty(name = "拼团价格", value = "拼团价格")
    private BigDecimal groupPrice;

    /**
    * 查询构造器
    */
    public static Product queryBuild( ProductQueryReq productQueryReq){
        return Product.builder()
                .name(productQueryReq.getName())
                .price(productQueryReq.getPrice())
                .groupPrice(productQueryReq.getGroupPrice())
                .build();
    }

    /**
    * 添加构造器
    */
    public static Product saveBuild(ProductSaveReq productSaveReq){
        return Product.builder()
                .name(productSaveReq.getName())
                .price(productSaveReq.getPrice())
                .groupPrice(productSaveReq.getGroupPrice())
                .build();
    }

    /**
    * 修改构造器
    */
    public static Product editBuild(Long id, ProductEditReq productEditReq){
        return Product.builder()
            .id(id)
                .name(productEditReq.getName())
                .price(productEditReq.getPrice())
                .groupPrice(productEditReq.getGroupPrice())
                .build();
    }

}
