package com.muyu.system.service.impl;

import java.util.List;

import com.muyu.common.core.utils.ObjUtils;
import com.muyu.system.domain.Product;
import com.muyu.system.mapper.ProductMapper;
import com.muyu.system.service.ProductService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author DongZeLiang
 * @date 2024-11-14
 */
@Slf4j
@Service
public class ProductServiceImpl extends ServiceImpl<ProductMapper, Product>  implements ProductService {

    /**
     * 查询【请填写功能名称】列表
     *
     * @param product 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<Product> list(Product product) {
        LambdaQueryWrapper<Product> queryWrapper = new LambdaQueryWrapper<>();


        if (ObjUtils.notNull(product.getName())){
            queryWrapper.like(Product::getName, product.getName());
        }

        if (ObjUtils.notNull(product.getPrice())){
            queryWrapper.eq(Product::getPrice, product.getPrice());
        }

        if (ObjUtils.notNull(product.getGroupPrice())){
            queryWrapper.eq(Product::getGroupPrice, product.getGroupPrice());
        }
        return list(queryWrapper);
    }
}
